-#!/bin/bash
+#!/usr/bin/env bash
# SPDX-License-Identifier: MIT
-set -x
-set -e
+set -o errexit
+set -o nounset
+set -o pipefail
+set -o xtrace
+
+cd "$(dirname "$0")"
unset LC_CTYPE
unset LANG
test -d linux || git clone https://github.com/AsahiLinux/linux
cd linux
git fetch -a -t
- git reset --hard origin/asahi-wip; git clean -f -x -d &> /dev/null
- curl -sL https://raw.githubusercontent.com/AsahiLinux/PKGBUILDs/main/linux-asahi/config > .config
- make olddefconfig
- make -j `nproc` V=0 > /dev/null
- sudo make modules_install
- sudo make install
+ git reset --hard asahi-6.1-rc8-3;
+ source "$HOME/.cargo/env"
+ cat ../../config-gpu.txt > .config
+ make LLVM=-15 olddefconfig
+ make -j `nproc` LLVM=-15 V=0 bindeb-pkg > /dev/null
)
}
test -d m1n1 || git clone --recursive https://github.com/AsahiLinux/m1n1
cd m1n1
git fetch -a -t
- git reset --hard origin/lina/gpu-wip; git clean -f -x -d &> /dev/null
+ git reset --hard v1.2.2;
make -j `nproc`
)
}
test -d u-boot || git clone https://github.com/AsahiLinux/u-boot
cd u-boot
git fetch -a -t
- # For tag, see https://github.com/AsahiLinux/PKGBUILDs/blob/main/uboot-asahi/PKGBUILD
- git reset --hard origin/asahi; git clean -f -x -d &> /dev/null
- curl -s https://tg.st/u/0001-usb-request-on-8-bytes-for-USB_SPEED_FULL-bMaxPacket.patch | git am -
+ git reset --hard asahi-v2022.10-1;
+
make apple_m1_defconfig
make -j `nproc`
)
-
cat m1n1/build/m1n1.bin `find linux/arch/arm64/boot/dts/apple/ -name \*.dtb` <(gzip -c u-boot/u-boot-nodtb.bin) > u-boot.bin
- sudo cp /boot/efi/m1n1/boot.bin /boot/efi/m1n1/`date +%Y%m%d%H%M`.bin
- sudo cp u-boot.bin /boot/efi/m1n1/boot.bin
+}
+package_boot_bin()
+{
+(
+ export M1N1_VERSION=1.2.2-1
+ rm -rf m1n1_${M1N1_VERSION}
+ mkdir -p m1n1_${M1N1_VERSION}/DEBIAN m1n1_${M1N1_VERSION}/usr/lib/m1n1/
+ cp u-boot.bin m1n1_${M1N1_VERSION}/usr/lib/m1n1/boot.bin
+cat > m1n1_${M1N1_VERSION}/DEBIAN/control <<EOF
+Package: m1n1
+Version: $M1N1_VERSION
+Section: base
+Priority: optional
+Architecture: arm64
+Maintainer: Thomas Glanzmann <thomas@glanzmann.de>
+Description: Apple silicon boot loader
+ Next to m1n1 this also contains the device trees and u-boot.
+EOF
+
+cat > m1n1_${M1N1_VERSION}/DEBIAN/postinst <<EOF
+#!/bin/bash
+
+export PATH=/bin
+cp /boot/efi/m1n1/boot.bin /boot/efi/m1n1/`date +%Y%m%d%H%M`.bin
+cp /usr/lib/m1n1/boot.bin /boot/efi/m1n1/
+EOF
+
+chmod 755 m1n1_${M1N1_VERSION}/DEBIAN/postinst
+)
+ dpkg-deb --build m1n1_${M1N1_VERSION}
}
mkdir -p build
cd build
-sudo apt-get install -y build-essential bash git locales gcc-aarch64-linux-gnu libc6-dev device-tree-compiler imagemagick ccache eatmydata debootstrap pigz libncurses-dev qemu-user-static binfmt-support rsync git flex bison bc kmod cpio libncurses5-dev libelf-dev:native libssl-dev dwarves
-
build_linux
build_m1n1
build_uboot
+package_boot_bin